#!/bin/bash
if test -z "$1"
then
    SVNSOURCE=http://www.wine-doors.org/svn/wine-doors/trunk/repos
else
    SVNSOURCE=$1
fi

if test -z "$2"
then
    REPOROOT=repositories
else
    REPOROOT=$2
fi
rm -rf $REPOROOT
echo "Checking out repository SVN source"
echo -n "   from: "
echo $SVNSOURCE
svn co $SVNSOURCE $REPOROOT > ./$REPOROOT.log 
cd $REPOROOT
find . -name .svn -exec rm -rf \{\} \; > /dev/null 2>&1
mkdir ../wd-icons > /dev/null 2>&1
echo "Copying all png/svg icons to the icons store" >> ../$REPOROOT.log
find . -iname \*.png -exec cp \{\} ../wd-icons/ \;
find . -iname \*.svg -exec cp \{\} ../wd-icons/ \;

for repo in `find * -maxdepth 0 -type d`;
do
    cd $repo
    echo -n "Building repository directory: " > ../$repo.log
    echo $repo >> ../$repo.log
    for i in `find * -type d -prune`; 
    do 
        echo -n "Creating application pack file: " >> ../$repo.log
        echo $i >> ../$repo.log
        echo "Creating gzipped tarball called $i.wdi" >> ../$repo.log
        tar -czvf $i.wdi `find $i/ -type f` >> ../$repo.log 2>&1
        echo "Removing folder $i" >> ../$repo.log
        rm -rf $i
    done
    echo -n "Compressing repository index" >> ../$repo.log
    gzip packlist.xml >> ../$repo.log
    cd ..
done

