import gtk, gobject
import sys, os, urllib, time
import re
import string

from const import *
from ctile import Tile
from preferences import preferences
from packlist import packlist
from queue import queue
from wine import wine
from autorun import autorun
import utils
import webbrowser
from log import log
from math import ceil
import time
from threading import Timer

# TODO: KDE BOYS!!!!!
# (GNOME, KDE) = range( 2 ) 
# if ui.type == KDE:
#   from qt-ui.py import *
# elif ui.typy == GNOME:
#   from gtk-ui.py import *
# Create replacement ui code for all functionality
# move following code to gtk-ui.py 

def benign():
    pass

def ReposFromModel(model, path, iter ):
    name = model.get_value( iter, REPO_NAME )
    uri = model.get_value( iter, REPO_URI )
    preferences.AddRepo( name, uri )

def SetProgress( percentage, type=POPUP, text=None, widget=None ):
    if type == WIDGET and widget:
        widget.set_text( text )
        widget.set_fraction( percentage )
    while gtk.events_pending():
        gtk.main_iteration()

def Complete( widget=None ):
    global complete
    packlist.GetInstalledPacks()
    packlist.DetermineAvailablePacks()

    if not widget:
        widget = winedoors.window['progressbar']

    widget.set_fraction( 1.0 )
    while gtk.events_pending():
        gtk.main_iteration()
    time.sleep(1) # Sleep for 1 second so the user sees the completed progress bar
                  # and stop bugging me about it.
    widget.hide()

    try:
        winedoors.window['pb_placeholder'].show()
        winedoors.window['bn_close'].set_sensitive(True)
        winedoors.window['bn_help'].set_sensitive(True)
        winedoors.window['cbe_filter'].child.set_text("")
        winedoors.window['cb_display'].set_sensitive(True)
        winedoors.tree.SetActive(winedoors.window['cb_display'].set_active(SHOW_AVAILABLE))
        winedoors.tree.model = gtk.ListStore( gobject.TYPE_PYOBJECT, 
                                              gobject.TYPE_STRING,
                                              gobject.TYPE_STRING )
        winedoors.tree.widget.set_model( winedoors.tree.CreateModel() )
        winedoors.tree.widget.set_search_column( PACK_SHORTNAME )
    except:
        log.Debug("Display invoked but couldn't display")

    try: complete['wn_complete'].show()
    except: complete = Window( "wn_complete" )   

    errors = log.GetErrors()
    log.ClearErrors()

    if len(errors) > 1:
        complete['image'].set_from_stock("gtk-dialog-error", -1)
        complete['lb_error'].set_markup("<b>The following errors were reported:</b>\n"+errors)
        complete['lb_error'].show()

class GladeHandlers:
    def on_bt_close_complete_clicked (widget, data=None):
        global complete
        complete['wn_complete'].hide()

    ''' About '''
    def on_bt_close_about_clicked( widget, data=None ):
        global about
        about['wn_about'].hide()
    def on_bt_about_credits_clicked( widget, data=None ):
        global credits
        try: credits['wn_credits'].show()
        except: credits = Window( "wn_credits" )
    def on_bt_credits_close_clicked( widget, data=None ):
        credits['wn_credits'].hide()
    
    '''  Wine Proc '''
    def on_bt_kill_pid_clicked ( widget, data=None ):
	global wineproc
        try:
            treeview = wineproc['treeview2']
            model = treeview.get_model()
            sel_proc_name = model.get_value( treeview.get_selection().get_selected()[1], 1 )
            sel_proc_pid  = model.get_value( treeview.get_selection().get_selected()[1], 0 )
            wine.Kill( sel_proc_name, sel_proc_pid )
        except AttributeError:
            # no process selected
            pass

    def on_bt_close_wineproc_clicked ( widget, data=None ):
        global wineproc
        wineproc['wn_wineproc'].hide() 
    
    ''' Preferences '''
    def on_bt_delete_repo_clicked( widget, data=None ):
        global wn_prefs
        selection = wn_prefs['tv_repos'].get_selection()
        item = selection.get_selected()
        if item:
            item[0].remove( item[1] )

    def on_bt_add_repo_clicked( widget, data=None ):
        global wn_prefs
        repo_name = wn_prefs['en_repo_name'].get_text()
        wn_prefs['en_repo_name'].set_text( "" )
        repo_uri = wn_prefs['en_repo_uri'].get_text()
        wn_prefs['en_repo_uri'].set_text( "" )
        model = wn_prefs['tv_repos'].get_model()
        
        if not model:
            log.Error("No repositories configured, did you run firstrun?\nTry: wine-doors --firstrun")
            Messages()
            return
            
        if repo_name == "" or repo_uri == "":
            return
        iter = model.append()
        model.set( iter, 
                  REPO_NAME, repo_name, 
                  REPO_URI, repo_uri )

    def on_bt_prefs_cancel_clicked( widget, data=None ):
        global wn_prefs
        wn_prefs['wn_prefs'].hide()

    def on_bt_prefs_ok_clicked( widget, data=None ):
        global wn_prefs
        preferences['wineroot']      = wn_prefs['file_wineroot'].get_current_folder() + "/"
        preferences['updateonstart'] = wn_prefs['ck_updateonstart'].get_active()
        preferences['cvscedega']     = wn_prefs['ck_cvscedega'].get_active()
        preferences['cedega']        = wn_prefs['ck_cedega'].get_active()
        preferences['crossover']     = wn_prefs['ck_crossover'].get_active() 
        preferences['licensed']      = wn_prefs['ck_licensed'].get_active()

        if preferences['winegtkcolours'] != wn_prefs['ck_winegtkcolours'].get_active():
            if wn_prefs['ck_winegtkcolours'].get_active():
                wine.SetColoursFromGtk()
            else:
                wine.SetDefaultColours()
            preferences['winegtkcolours']= wn_prefs['ck_winegtkcolours'].get_active()

        preferences['name']          = wn_prefs['en_name'].get_text()
        wine.SetRegOwner( wn_prefs['en_name'].get_text() )

        preferences['company']       = wn_prefs['en_company'].get_text()
        wine.SetRegCompany( wn_prefs['en_company'].get_text() )

        preferences['hideprograms']  = wn_prefs['ck_showwinemenu'].get_active()
        preferences['installedfromreg'] = wn_prefs['installedfromreg'].get_active()

        if wn_prefs['ck_showwinemenu'].get_active():
            os.chmod( os.path.expanduser("~/.local/share/applications/wine"), 0755)
        else:
            os.chmod( os.path.expanduser("~/.local/share/applications/wine"), 0000)

        # Set winver
        selected_win_version = wine.GetWindowsVersions()[wn_prefs['cb_winver'].get_active()]
        if selected_win_version != wine.GetWindowsVersion():
            wine.SetWindowsVersion( selected_win_version )

        # Set audio backend
        selected_audio_backend = wn_prefs['cb_audio'].get_active_text()
        if selected_audio_backend != wine.GetAudioSystem():
            wine.SetAudioSystem( selected_audio_backend )
        del selected_audio_backend

        # Refresh ctile
        winedoors.tree.widget.set_model( winedoors.tree.CreateModel() )

        model = wn_prefs['tv_repos'].get_model()
        model.foreach( ReposFromModel )

        preferences.Save()
        wn_prefs['wn_prefs'].hide()

    ''' Error handling dialogs '''    
    def on_bn_installerpath_retry_clicked( widget, data=None ):
        global wn_installerpath
        wn_installerpath["wn_installerpath"].hide()
        # Redetect cd
        GH_Main().on_install_cd_activate()
    
    def on_bn_installerpath_browse_clicked( widget, data=None ):
        # FIXME: This is messy
        button = ("Run", 1)
        filter = gtk.FileFilter()
        filter.add_pattern("*.exe")
        filter.add_pattern("*.msi")
        file = gtk.FileChooserDialog("Please locate installer on CD", None, gtk.FILE_CHOOSER_ACTION_OPEN, button)
        file.set_filter(filter)
        # Ok button will return 1
        if file.run() == 1:
            file.hide()
            wine.Execute( file.get_uri() )
        else:
            file.hide()
        
    def on_bn_installerpath_cancel_clicked( widget, data=None ):
        global wn_installerpath
        wn_installerpath["wn_installerpath"].hide()
    
    def on_bn_error_close_clicked( widget, data=None ):
        global wn_errors
        wn_errors['wn_errors'].hide()
        
    ''' Generic Installer '''
    def GenericInstall ( widget, data=None ):
        global wn_generic_installmodel
        try:
            wn_generic_install['wn_generic_instrall'].show()
        except:
            wn_generic_install = Window( "wn_generic_install" )

def Messages():
    global wn_errors
    if log.errors:
        try:
            wn_errors['wn_errors'].show()
        except:
            wn_errors = Window( "wn_errors" )
    else:
        return
    error_text = "<b>The following errors have been reported</b>\n"
    error_text += log.GetErrors()
    wn_errors['lb_error'].set_markup( error_text )


class CantFindFile:
    def __init__ (self, title=None, message=None ):
        global wn_installer
        # We need to keep some kind of record of who called us and why
        # and how to send the file location back to them?    
        if not title:
            title = "Warning: Can't locate file"
        if not message:
            message = "<b>WARNING</b>\nThis is a default can't find file message"
        
        try:
            wn_installer['wn_installerpath'].show()
        except:
            wn_installer = Window( "wn_installerpath" )
        wn_installer['lb_error'].set_text( message )
        wn_installer['wn_installerpath'].set_title( title )

    def retry(self):
        if not os.path.isfile(self.path):
            return False
        return True        
    def setpath( self, path ):
        self.path = path
    def run(self):
        pass    
    
class GH_FirstRun:
    def on_bt_proceed_clicked( widget, data=None ):
        window['bt_proceed'].set_sensitive(False)
        window['bt_cancel'].set_sensitive(False)
        preferences["name"]     = window['en_name'].get_text()
        preferences["company"]  = window['en_company'].get_text()
        preferences['licensed'] = window['ck_licensed'].get_active()
        preferences.Save()
        wine.CreateDrive()
        queue.AddBaseLibraries()
        #queue.SetProgress( 0, window['progressbar'] )
        gobject.idle_add( queue.Execute( True ).next )
        
    def on_firstrun_cancel_clicked( widget, data=None ):
        gtk.main_quit()
        sys.exit( 0 )
    def quit( widget, data=None ):
        log.Debug( "Quit called" )
        gtk.main_quit()

class GH_Main:
    def quit( widget, data=None ):
        log.Debug( "Quit called" )
        gtk.main_quit()
                  
    ''' Buttons '''
    def on_bn_update_clicked ( widget, data=None ):
        packlist.UpdateAll()
    
    def on_bn_process_queue_clicked( widget, data=None ):
        winedoors.window['bn_process_queue'].set_sensitive(False)
        winedoors.window['bn_close'].set_sensitive(False)
        winedoors.window['bn_help'].set_sensitive(False)
        winedoors.window['cb_display'].set_sensitive(False)
        winedoors.window['cbe_filter'].child.set_text("")
        try:
            winedoors.tree.SetActive(winedoors.window['cb_display'].set_active(SHOW_QUEUE))
            winedoors.tree.model = gtk.ListStore( gobject.TYPE_PYOBJECT, 
                                                  gobject.TYPE_STRING,
                                                  gobject.TYPE_STRING )
            winedoors.tree.widget.set_model( winedoors.tree.CreateModel() )
            winedoors.tree.widget.set_search_column( PACK_SHORTNAME )
        except:
            log.Debug("Display invoked but couldn't display")
        winedoors.window['pb_placeholder'].hide()
        winedoors.window['progressbar'].show()
        queue.SetProgress( 0, winedoors.window['progressbar'])
        gobject.idle_add( queue.Execute( False ).next )
        
    ''' Menu '''
    def on_update_package_list_activate ( widget, data=None ):
        utils.ClearCache()
        winedoors.tree.packs = None
        packlist.UpdateAll()
        winedoors.tree.model = winedoors.tree.CreateModel()

    def on_regen_menu_activate( widget, data=None ):
        # EVIL! I tells ya
        application = __import__("application")
        for pack in packlist.installed:
            application.ApplicationPack( DESKTOP, packlist.GetRepoURI( packlist.GetRepo( \
            pack['shortname'] )[0] ) + pack['versions'][0][0][8], pack['versions'][0][0][0])
        del application
        
    def on_install_cd_activate( widget, data=None ):
        # Game supports autorun
        if autorun.detect_cd():
            autorun.start()
        # Can't detect autorun.
        else:
            global wn_installerpath
            try:
                wn_installerpath["wn_installerpath"].present()
            except NameError:
                wn_installerpath = Window("wn_installerpath")

    def on_install_from_file_activate( widget, data=None ):
            pass #TODO

    def update_proclist():
        global wineproc

        print "Running update_proclist"

    def on_view_wine_processes_activate( widget, data=None ):
        global wineproc

        try:
            wineproc['wn_wineproc'].show()
        except:
            wineproc = Window( "wn_wineproc" )
            column = gtk.TreeViewColumn("Wine Proccesses", gtk.CellRendererText(), text=1)
            column.set_sort_column_id(1)
            wineproc['treeview2'].append_column(column)
            liststore = gtk.ListStore(str, str)
            wineproc['treeview2'].set_model( liststore )

        for output in wine.ListProcesses():
            wineproc['treeview2'].get_model().append( output )
        wineproc['treeview2'].show_all()
            
    def on_kill_all_wine_processes_activate ( widget, data=None ):
        wine.KillAll()
        
    def on_reboot_wine_activate ( widget, data=None ):
        wine.Reboot()
        
    def on_quit_activate( widget, data=None ):
        gtk.main_quit()
        
    def on_preferences_activate( widget, data=None ):
        global wn_prefs
        try:
            wn_prefs['wn_prefs'].show()
        except:
            wn_prefs = Window( "wn_prefs" )
            column = gtk.TreeViewColumn( 'Repository Name', gtk.CellRendererText(), text=REPO_NAME )
            column.set_sort_column_id( REPO_NAME )
            wn_prefs['tv_repos'].append_column( column )
            
            column = gtk.TreeViewColumn( 'Repository URI', gtk.CellRendererText(), text=REPO_URI )
            column.set_sort_column_id( REPO_URI )
            wn_prefs['tv_repos'].append_column( column )
            
        wn_prefs['file_wineroot'].set_current_folder( preferences['wineroot'] )
        wn_prefs['ck_updateonstart'].set_active( utils.string2bool( preferences['updateonstart']) )
        wn_prefs['ck_cvscedega'].set_active( utils.string2bool( preferences['cvscedega'] ) )
        wn_prefs['ck_cedega'].set_active( utils.string2bool( preferences['cedega'] ) )
        wn_prefs['ck_crossover'].set_active( utils.string2bool( preferences['crossover'] ) )
        wn_prefs['ck_licensed'].set_active( utils.string2bool( preferences['licensed'] ) )
        if utils.GetPermissions(os.path.expanduser("~/.local/share/applications/wine")):
            wn_prefs['ck_showwinemenu'].set_active(True)
        wn_prefs['installedfromreg'].set_active( utils.string2bool( preferences['installedfromreg'] ) )
        wn_prefs['ck_winegtkcolours'].set_active( utils.string2bool( preferences['winegtkcolours'] ) )
        wn_prefs['en_name'].set_text( preferences['name' ] )
        wn_prefs['en_company'].set_text( preferences['company'] )

        # Add available cedega engines to cb_winever
        #if os.path.isdir( os.path.expanduser("~/.cedega/.winex_ver/") ):
        #    for engine in os.listdir( os.path.expanduser("~/.cedega/.winex_ver/") ):
        #        wn_prefs['cb_winever'].prepend_text( engine.replace("winex", "cedega") )

        # Do winver
        win_versions_model = gtk.ListStore( gobject.TYPE_STRING, # Display name
                                            gobject.TYPE_STRING, # CurrentVersion
                                            gobject.TYPE_STRING, # Build
                                            gobject.TYPE_INT,    # Platform
                                            gobject.TYPE_STRING )# Service Pack
        win_versions = wine.GetWindowsVersions()
        set_win_version = wine.GetWindowsVersion()
        wn_prefs['cb_winver'].set_model( win_versions_model )
        for i in xrange( len( win_versions ) ):
            win_versions_model.append( win_versions[i] )
            if set_win_version == win_versions[i]:
                wn_prefs['cb_winver'].set_active( i )

        # Detect wineversion and leave it at that
        winever_model = gtk.ListStore( gobject.TYPE_STRING )
        winever_model.append( [ wine.WineVersion() ] )
        wn_prefs['cb_winever'].set_model( winever_model )
        wn_prefs['cb_winever'].set_active(0)

        # Do audio
        audio_model = gtk.ListStore( gobject.TYPE_STRING )
        audio_systems = wine.GetAudioSystems()
        wn_prefs['cb_audio'].set_model( audio_model )
        for i in xrange( ( len( audio_systems ) ) ):
            audio_model.append( [ audio_systems[i] ] )
            if audio_systems[i] == wine.GetAudioSystem():
                wn_prefs['cb_audio'].set_active(i)
        
        model = gtk.ListStore( gobject.TYPE_STRING, 
                               gobject.TYPE_STRING )
        for item in preferences.repositories:
            iter = model.append()
            model.set( iter, 
                      REPO_NAME, item[REPO_NAME], 
                      REPO_URI, item[REPO_URI] )
            
        wn_prefs['tv_repos'].set_model( model )
        wn_prefs['tv_repos'].set_search_column( REPO_NAME )
    
    def on_joystick_activate( widget, data=None ):
        pass

    def on_cedega_preferences1_activate( widget, data=None):
        pass

    def on_cedega_profiles_activate( widget, data=None):
        pass

    def on_wine_version_activate( widget, data=None ):
        # TODO: Non-blocking wine.Execute
        wine.Execute("winver")

    def on_contents_activate( widget, data=None ):
        pass

    def on_about_activate( widget, data=None ):
        global about
        try: about['wn_about'].show()
        except: about = Window( "wn_about" )

    def on_tv_packlist_cursor_changed( widget, data=None ):
        """
        packlist cursor change
        
        This should probably be some kind of html renderer, allowing some basic online browsing.
        initial UI should be generated locally, online links should be made inactive when the user
        is not connected to the internet. The best bet for this is more than likely gtkmozembed.
        """
        
        global pack
        treeiter = widget.get_selection().get_selected()[1]
        model = widget.get_model()
        shortname = model.get_value( treeiter, PACK_SHORTNAME )
        for item in packlist.all:
            if item["shortname"] == shortname:
                pack = item
                break
        if pack:
            winedoors.window['lb_vendor'].set_text( pack["vendor"] )
            winedoors.window['lb_homepage'].set_text( pack['homepage'] )
            winedoors.window['lb_category'].set_text( pack['category'] )
        
    def on_cb_display_changed( widget, data=None ):
        try:
            winedoors.window['cbe_filter'].child.set_text("")
            winedoors.tree.SetActive(winedoors.window['cb_display'].get_active())
            winedoors.tree.model = gtk.ListStore( gobject.TYPE_PYOBJECT, 
                                                  gobject.TYPE_STRING,
                                                  gobject.TYPE_STRING )
            winedoors.tree.widget.set_model( winedoors.tree.CreateModel() )
            winedoors.tree.widget.set_search_column( PACK_SHORTNAME )
        except:
            log.Debug("Display invoked but couldn't display")
        
    def on_cb_filter_changed( widget, data=None ):
        try:
            filter_text = winedoors.window['cbe_filter'].child.get_text()
            filter_field = winedoors.window['cb_filter'].get_active()
        except NameError:
            log.Debug("can't get values from widgets")
            filter_field = 0
            filter_text = ""
            return

        if filter_field == 0:
            filter_field = ANY
        elif filter_field == 1:
            filter_field = NAME
        elif filter_field == 2:
            filter_field = DESCRIPTION
        elif filter_field == 3:
            filter_field = CATEGORY
        elif filter_field == 4:
            filter_field = REPOSITORY
        elif filter_field == 5:
            filter_field = VENDOR
            
        try:
            winedoors.tree.FilterModel(filter_text, filter_field)
            winedoors.tree.FilterModel(filter_text, filter_field)
        except NameError:
            log.Debug("filter invoked but couldn't filter")
        
class WDTileCellRenderer ( gtk.GenericCellRenderer ):
    __gproperties__ = {
        "data": ( gobject.TYPE_PYOBJECT, "Data", "Data", gobject.PARAM_READWRITE ), 
    }
   
    def __init__( self ):
        self.__gobject_init__()
        self.height = 60
        self.width = 400
        self.set_fixed_size(self.width, self.height)
        self.data = None
        
    def do_set_property( self, pspec, value ):
        setattr( self, pspec.name, value )
        
    def do_get_property( self, pspec ):
        return getattr( self, pspec.name )
		
    def on_render( self, window, widget, background_area, cell_area, expose_area, flags ):
        if not self.data: return
        cairo = window.cairo_create()
        tile_data, tile_status, buttons, height, opacity = self.data
        title, icon, description, votes, rating = tile_data
        
        x, y, width, h = cell_area
        ydiff = int(float(h - height) / 2)
        y += ydiff
        if height > 0:
            x = ydiff
            
        width = width - 2*ydiff
        cell_area = gtk.gdk.Rectangle(x, y, width, height)
        Tile(cairo, True,
             title, 
             icon,
             description,
             votes, rating, tile_status, buttons, 
             cell_area,opacity )#, animation )
    def on_get_size( self, widget, cell_area=None ):
        return ( 0, 0, self.width, self.height )

gobject.type_register( WDTileCellRenderer )
           
class PackTree:
    def __init__( self, widget, window ):
        self.path = None
        self.widget = widget
        self.window = window
        self.queue = False
        self.frame = None
        self.anim = False
        log.Debug("Creating a packtree")
        if preferences['updateonstart']:
            packlist.UpdateAll()

        self.model = gtk.ListStore( gobject.TYPE_PYOBJECT, 
                                    gobject.TYPE_STRING,
                                    gobject.TYPE_STRING )
        
        column = gtk.TreeViewColumn( 'Application', WDTileCellRenderer(), data=PACK_TILE )
        column.set_sort_column_id( PACK_TILE )
        self.widget.append_column( column )
        
        column = gtk.TreeViewColumn( 'shortname', gtk.CellRendererText(), text=PACK_SHORTNAME )
        column.set_sort_column_id( PACK_SHORTNAME )
        column.set_visible( False )
        self.widget.append_column( column )
        
        column = gtk.TreeViewColumn( 'version', gtk.CellRendererText(), text=PACK_VERSION )
        column.set_sort_column_id( PACK_VERSION )
        column.set_visible( False )
        self.widget.append_column( column )
        
        self.SetActive()
        self.packs = packlist.available
        self.widget.set_model( self.CreateModel() )
        self.widget.set_search_column( PACK_SHORTNAME )
        
        self.button_press = False
        self.widget.connect("motion-notify-event", self.motion_notify)
        self.widget.connect("button-press-event", self.on_button_press)
        self.widget.connect("button-release-event", self.on_button_release)
        
    def SetActive(self, index=None):
        if index:
            self.window['cb_display'].set_active(index)
        
        self.active = self.window['cb_display'].get_active()
        if self.active != SHOW_QUEUE:
            self.window['cbe_filter'].set_sensitive(True)
            self.window['cb_filter'].set_sensitive(True)
        if self.active == SHOW_ALL:
            self.packs = packlist.all
            packlist.packs = packlist.all
        elif self.active == SHOW_AVAILABLE:
            self.packs = packlist.available
            packlist.packs = packlist.available
        elif self.active == SHOW_UPDATES:
            self.packs = packlist.updates
            packlist.packs = packlist.updates
        elif self.active == SHOW_INSTALLED:
            self.packs = packlist.installed
            packlist.packs = packlist.installed
        elif self.active == SHOW_QUEUE:
            self.window['cbe_filter'].set_sensitive(False)
            self.window['cb_filter'].set_sensitive(False)
            self.packs = queue.queue
        else:
            self.queue = False
            self.packs = packlist.available
        
    def on_button_press( self, widget=None, event=None ):
        '''
        Set the mouse button as down
        '''
        retval = False
        button = event.button
        x = int(event.x)
        y = int(event.y)

        if button != 1:
            return
        self.button_press = True
        self.motion_notify(widget, event, click=True)
        
    def on_button_release ( self, widget=None, event=None ):
        '''
        Set the mouse button as up, identify button push or new rating vote
        make vote submission via XML-RPC
        '''
        self.button_press = False
        self.path = None
        
    def motion_notify( self, widget=None, event=None, click=False):
        '''
        Get position of the mouse in relation to the current tile, drop if the left button
        isn't being held. 
        '''
            
        x = int(event.x)
        y = int(event.y)
        
        if event.window is widget.get_bin_window():
            t = widget.get_path_at_pos(x, y)
            if not t:
                return
            path, col, cx, cy = t
                
            cell_area = widget.get_cell_area(path, widget.get_column(PACK_TILE))
            
            if not self.path:
                self.path = path
                
            if path == self.path:
                self.update_cell( widget, path, cx, cy, click)
                
    def update_cell( self, widget, path, x, y, click=False):
        cairo = widget.window.cairo_create()
        try:
            treeiter = self.model.get_iter( path )
        except:
            return
        data = self.model.get_value( treeiter, PACK_TILE )
        shortname = self.model.get_value( treeiter, PACK_SHORTNAME )
        version = self.model.get_value( treeiter, PACK_VERSION )
        
        tile_data, tile_status, buttons, height, opacity = data
        title, icon, description, old_votes, rating = tile_data
        status_text, status_image, status_frame = tile_status
        
        cell_area = widget.get_cell_area(path, widget.get_column(PACK_TILE))
        (a,b,w,h) = cell_area
        cell_area = gtk.gdk.Rectangle(a, b, w, height)
        dummy = Tile(cairo, False, title, icon, description, old_votes, rating, tile_status, buttons, cell_area )
        
        signal = dummy.GetButtonAtPosition(x,y)
        if signal:
            widget.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.HAND2))
        else:
            widget.window.set_cursor(None)
            
        if self.button_press == False:
            return
        self.widget = widget
        if click and signal:
            if signal == "install":
                self.on_install_click( path, shortname, version )
            elif signal == "update":
                self.on_update_click( path, shortname, version )
            elif signal == "uninstall":
                self.on_uninstall_click( path, shortname, version )
            elif signal == "buy":
                self.on_buy_click( path, shortname, version )
            elif signal == "appdb":
                self.on_appdb_click( path, shortname, version )
            elif signal == "unqueue":
                self.on_unqueue_click( path, shortname, version )
            return
            
#         The elipsis code in ctile.py breaks this #976
#        if click and not dummy.IsOnRating(x,y):
#            return
#        votes = dummy.GetRatingAtPosition(x,y)
#        (x,y,w,h) = cell_area
#        if old_votes != votes:
#            status_text = "Vote registered"
#            tile_status = status_text, status_image, status_frame
#            tile_data = title, icon, description, votes, rating
#            data = tile_data, tile_status, buttons, height, opacity           
#            self.model.set_value(treeiter, PACK_TILE, data)
#            packlist.SetRating(self.window['cb_display'].get_active(), shortname, version, votes)
            
        
    def on_install_click( self, path, shortname, version ):
        log.Debug("Adding to install queue %s %s" % (shortname, version) )
        pack = packlist.GetPack( shortname )
        [repo] =  pack['repo'][0:1]
        log.Debug("From Repo: " + repo )
        queue.Add( INSTALL, shortname, version, repo )
        self.window['bn_process_queue'].set_sensitive(True)

        if self.active != SHOW_ALL:
            gobject.timeout_add(33, self.fade_cell, path, "Added to install queue", "upgrade" )
        else:
            self.set_cell_status(path, "Added to install queue", "upgrade")
    
    def on_update_click( self, path, shortname, version ):
        log.Debug("Adding to update queue")
        pack = packlist.GetPack( shortname )
        [repo] =  pack['repo'][0:1]
        log.Debug("From Repo: " + repo )
        queue.Add( UPDATE, shortname, version, repo )
        self.window['bn_process_queue'].set_sensitive(True)
        if self.active != SHOW_ALL:
            gobject.timeout_add(33, self.fade_cell, path, "Added to update queue", "upgrade" )
        else:
            self.set_cell_status(path, "Added to update queue", "upgrade")

    def on_uninstall_click( self, path, shortname, version ):
        log.Debug("Adding to uninstall queue")
        pack = packlist.GetPack( shortname )
        [repo] =  pack['repo'][0:1]
        log.Debug("From Repo: " + repo )
        queue.Add( UNINSTALL, shortname, version, repo )
        self.window['bn_process_queue'].set_sensitive(True)
        if self.active != SHOW_ALL:
            gobject.timeout_add(33, self.fade_cell, path, "Added to uninstall queue", "upgrade" )
        else:
            self.set_cell_status(path, "Added to uninstall queue", "upgrade")

    def on_buy_click( self, path, shortname, version ):
        # Launch gnome default web browser at purchase uri
        pass

    def on_appdb_click( self, path, shortname, version ):
        # Launch gnome default web browser at appdb uri
        appdb_uri = "http://www.google.co.uk/search?hl=en&q=site%3Aappdb.winehq.org+%s+%s&btnI" % ( shortname, version )
        webbrowser.open_new_tab( appdb_uri )
    
    def on_unqueue_click( self, path, shortname, version ):
        log.Debug("Removing from install queue %s %s" % (shortname, version) )
        queue.Delete( shortname, version )
        if len(queue.queue) == 0:
            self.window['bn_process_queue'].set_sensitive(False)
        gobject.timeout_add(33, self.fade_cell, path, "Removing from queue" )
    
    def fade_cell( self, path, text=None, image=None, delta=4 ):
        self.anim = False
        treeiter = self.model.get_iter( path )
        data = self.model.get_value( treeiter, PACK_TILE )
        shortname = self.model.get_value( treeiter, PACK_SHORTNAME )
        version = self.model.get_value( treeiter, PACK_VERSION )
        
        tile_data, tile_status, buttons, height, opacity = data
        title, icon, description, votes, rating = tile_data
        status_text, status_image, status_frame = tile_status
        
        keepgoing = False
        if text:
            status_text = text
        status_image = image
        status_frame = None

        if opacity >= delta:
            opacity = opacity - delta
            keepgoing = True
        if opacity < delta:
            opacity = 0
            self.model.remove(treeiter)
            return
        
        tile_status = status_text, status_image, status_frame
        tile_data = title, icon, description, votes, rating
        data = tile_data, tile_status, buttons, height, opacity
        
        if keepgoing:
            self.model.set_value(treeiter, PACK_TILE, data)
            cell_area = self.widget.get_cell_area(path, self.widget.get_column(PACK_TILE))
            (x,y,w,h) = cell_area
            while gtk.events_pending():
                gtk.main_iteration()
            self.widget.queue_draw_area(x,y,w,h)
            return True
        else:
            self.set_cell_status(path, "")
            return False

    def set_cell_status( self, path, text, newimage=None ):
        treeiter = self.model.get_iter( path )
        data = self.model.get_value( treeiter, PACK_TILE )
        shortname = self.model.get_value( treeiter, PACK_SHORTNAME )
        version = self.model.get_value( treeiter, PACK_VERSION )
        
        tile_data, tile_status, buttons, height, opacity = data
        title, icon, description, votes, rating = tile_data
        status_text, status_image, status_frame = tile_status

        status_text = text
        if newimage:
            status_image = newimage
        tile_status = status_text, status_image, self.frame
        tile_data = title, icon, description, votes, rating
        data = tile_data, tile_status, buttons, height, opacity
        
        self.model.set_value(treeiter, PACK_TILE, data)
        cell_area = self.widget.get_cell_area(path, self.widget.get_column(PACK_TILE))
        (x,y,w,h) = cell_area
        while gtk.events_pending():
           gtk.main_iteration()
        self.widget.queue_draw_area(x,y,w,h)

    def throb_cell ( self, path ):
        try:
            treeiter = self.model.get_iter( path )
        except:
            self.anim = False
            return self.anim
        data = self.model.get_value( treeiter, PACK_TILE )
        shortname = self.model.get_value( treeiter, PACK_SHORTNAME )
        version = self.model.get_value( treeiter, PACK_VERSION )
        
        tile_data, tile_status, buttons, height, opacity = data
        title, icon, description, votes, rating = tile_data
        status_text, status_image, status_frame = tile_status

        if not self.anim:
            status_image = None
        else:
            if self.frame == None:
                self.frame = 0
            else:
                self.frame -= 1
                self.frame %= 12

        status_image = "throbber"
        
        tile_status = status_text, status_image, self.frame
        tile_data = title, icon, description, votes, rating
        data = tile_data, tile_status, buttons, height, opacity
        if self.anim:
            self.model.set_value(treeiter, PACK_TILE, data)
            cell_area = self.widget.get_cell_area(path, self.widget.get_column(PACK_TILE))
            (x,y,w,h) = cell_area
            while gtk.events_pending():
                gtk.main_iteration()
            self.widget.queue_draw_area(x,y,w,h)
        return self.anim
            
    def FilterModel( self, string, filter_fields ):
        filtered_packs = []
        self.SetActive()
        try:
            re_filter = re.compile( '.*%s.*' % string, re.I | re.M )
        except sre_constants.error:
            log.Info( "Invalid regex entered in search filter" )
            return
        hit = False
        for index, pack in enumerate(self.packs):
            if filter_fields == ANY:
                text = pack['name'] + " " + \
                       pack['description'] + " " + \
                       pack['vendor'] + " " + \
                       pack['category'] + " " + \
                       pack['repo'][0]
            elif filter_fields == NAME:
                text = pack['name']
            elif filter_fields == REPOSITORY:
                text = pack['repo'][0]
            elif filter_fields == DESCRIPTION:
                text = pack['description']
            elif filter_fields == CATEGORY:
                text = pack['category']
            elif filter_fields == VENDOR:
                text = pack['vendor']
                
            if re_filter.match( text ):
                hit = True
                log.Debug("Matched application " + pack['name'] + " in search text " + text )
                filtered_packs.append( pack )
        
        self.model = gtk.ListStore( gobject.TYPE_PYOBJECT, 
                                    gobject.TYPE_STRING,
                                    gobject.TYPE_STRING )
        if hit:
            self.widget.set_model( self.CreateModel( filtered_packs ) )
        else:
            self.widget.set_model( self.model )
            
    def CreateModel( self, packs=None ):

        if packs:
            self.packs = packs
        elif self.active == SHOW_QUEUE:
            self.packs = queue.queue
            
        if not self.packs:
            self.packs = packlist.available

        self.model = gtk.ListStore( gobject.TYPE_PYOBJECT, 
                                    gobject.TYPE_STRING,
                                    gobject.TYPE_STRING )

        for item in self.packs:
            if self.active == SHOW_QUEUE:
                (action, shortname, thisversion, repo)  = item
                pack = packlist.GetPack(shortname)
            else:
                pack = item

            wdicons = os.path.expanduser("~/.wine-doors/icons/")
            if not os.path.isdir( wdicons ):
                os.makedirs( wdicons )
                
            try:
                icon_url = pack['icon'].split( "/" )
                icon_file = wdicons + icon_url[len( icon_url )-1]
            except:
                log.Debug("Can't find icon")
                icon_file = "default" #FIXME
            # This is total crack!
            if not os.path.isfile( icon_file ):

                proxyfromgconf = utils.GetProxyFromGconf()
                if proxyfromgconf:
                        proxies = { 'http': proxyfromgconf }
                        urllib._urlopener = urllib.FancyURLopener( proxies )
                else:
                    log.Debug("Can't use gconf for proxy configuration")
                urllib.urlretrieve( pack['icon'], icon_file )
            
            if pack['name'] == "":
                continue;
            
            # ms-license shite.. but better :D
            if utils.string2bool( pack['ms-license'] ) and not utils.string2bool( preferences['licensed'] ):
                continue;

            title = pack['name']
            icon = icon_file
            description = pack['description']
            
            for pack_version in pack['versions']:
                [( majorversion, 
                   wineversion, 
                   winevariant, 
                   appdb_rating, 
                   installersize, 
                   installedsize, 
                   votes,
                   version,
                   app_pack )] = pack_version
                
                buttons = []
                
                update    = packlist.IsUpdate(pack['shortname'], version)
                installed = packlist.IsInstalled(pack['shortname'], majorversion)
                req_lic   = packlist.RequiresLicense(pack['shortname'], majorversion)
                has_lic   = packlist.HaveLicense(pack['shortname'], majorversion)
                onqueue   = queue.IsOnQueue(pack['shortname'], majorversion)
                
                if self.active == SHOW_QUEUE and not thisversion in (majorversion, version): #majorversion != thisversion:
                    continue
                if self.active == SHOW_AVAILABLE and onqueue:
                    continue

                if onqueue and self.active == SHOW_QUEUE:
                    buttons.append( ("Delete from queue", "unqueue") )
                elif onqueue and self.active != SHOW_QUEUE:
                    pass
                elif update:
                    buttons.append( ("Update", "update") )
                elif not installed and req_lic and not has_lic:
                    buttons.append( ("Install trial", "install") )
                elif not installed and req_lic and has_lic:
                    buttons.append( ("Install", "install") )
                elif not installed and not req_lic:
                    buttons.append( ("Install", "install") )
                elif installed:
                    buttons.append( ("Uninstall", "uninstall") )
                
                if req_lic and not has_lic:
                    buttons.append( ("Buy", "buy") )

                buttons.append( ("More info...", "appdb") )
                try:
                    rating = string.lower(appdb_rating)
                    votes = eval(votes)
                except:
                    try:
                        votes = int(votes)
                    except:
                        rating = "gold"
                        votes = eval(appdb_rating)
                
                status_text = None
                status_image = None
                
                if installed:
                    status_image = "installed"

                if onqueue:
                    status_text = "On queue"
                    status_image = "upgrade"
                
                tile_status = status_text, status_image, None
                tile_data = title + " " + majorversion, icon, description, votes, rating
                data = tile_data, tile_status, buttons, 60, 100

                self.model.append([data, pack['shortname'], majorversion])
                
        return self.model

    def SetFrame( self, frame ):
        pass

    def SetStatus( self, status ):
        pass 

class WineDoorsGUI:
    def __init__( self ):
        preferences.Save()
        preferences.Load()

        try:
            # New method to detect connection (throws and exception if the link is down)
            # Not quite as pretty, but seemingly cross-platform and has no deps
            import urllib2
            proxyfromgconf = utils.GetProxyFromGconf()
            if proxyfromgconf:
                proxy_support = urllib2.ProxyHandler( {"http": proxyfromgconf} )
                opener = urllib2.build_opener( proxy_support )
                urllib2.install_opener( opener )
            request = urllib2.Request( "http://www.wine-doors.org" )
            request.get_method = lambda: "HEAD"
            urllib2.urlopen( request )

        except:
            self.window = Window("wn_nonetwork", GH_Main )
            return

        self.window = Window( "wn_winedoors", GH_Main )
        self.PopulateFilter()
        self.tree = PackTree( self.window['tv_packlist'], self.window )
        self.window['cb_display'].set_active(SHOW_AVAILABLE)
        self.window['cb_filter'].set_active(0)

    def __getitem__( self, key ):
        if key == "window":
            return self.window['wn_winedoors']
        return self.window[ key ]
    
    def PopulateFilter( self ):
    	# Create a list of relevent options from the filter selection
    	# populate the combo entry drop down list
    	pass

class Window:
    def __init__( self, window_name, Handlers=None ):
        glade = os.path.join( sys.path[0], 'winedoors.glade')
        if not os.path.isfile(glade):
            glade = os.path.join("/usr/share/wine-doors/src/", 'winedoors.glade')
        if not os.path.isfile(glade):
            glade = os.path.join(os.path.expanduser("~/.local/share/wine-doors/src"), 'winedoors.glade')
        self.widgets = gtk.glade.XML( glade, window_name )
        if not Handlers:
            Handlers = GladeHandlers
        self.widgets.signal_autoconnect( Handlers.__dict__ )
        
    def __getitem__( self, key ):
        return self.widgets.get_widget( key )
            
if __name__ == "__main__":
    winedoors = WineDoorsGUI()
    gtk.main()
