import sys, os, time, re, string, pwd
import gtk, gobject, gtk.glade
import shutil
#import ui
from log import log
import urllib
import md5
import preferences
import commands
from const import *
import gconf

def GetPermissions( item ):
    return int( commands.getoutput( "stat -c%a " + item ) )

def GetXkbmap():
    xkbmap_regex = re.compile( '_XKB_RULES_NAMES\(STRING\) = "[^\"]*", "[^\"]*", "([^\"]*)"' )
    return xkbmap_regex.search( commands.getoutput( "xprop -root" ) ).group( 1 )

def GetCDMountPoint():
    #from log import log
    mtab = "/etc/mtab"
    getName = lambda x: x.split( "/" )[-1]
    if not os.path.exists( mtab ):
        log.Warn( "Wasn't able to locate mtab" )
        cd = GetCD()
        return [ cd ]
    
    list = []
    for line in file( "/etc/mtab" ):
        mpoint, fsys = line.split()[1:3]
        if fsys == "iso9660" or fsys == "cd9960":
            log.Log( "Detected CD drive " + mpoint )
            list.append( mpoint )
    
    if not list:
        cd = GetCD()
        return [ cd ]
    
    return list

def GetProxyFromGconf():
    """Returns proxy from gconf, returns false if none set or unable to use gconf"""
    gconf_client = gconf.client_get_default()
    use_proxy = gconf_client.get_bool("/system/http_proxy/use_http_proxy")
    if use_proxy:
        host = gconf_client.get_string("/system/http_proxy/host")
        port = gconf_client.get_int("/system/http_proxy/port")
        if len(str(host)) > 1:
            return "http://%s:%i" % ( host, port )
    return False
    
def GetCD():
    cdpath = False
    # Lifted almost completely out of freevo (thanks dischi ;)
    if not os.path.isfile( '/etc/fstab' ):
        return cdpath
    re_cd        = re.compile( '^(/dev/cdrom[0-9]*|/dev/[am]?cd[0-9]+[a-z]?)[ \t]+([^ \t]+)[ \t]+', re.I )
    re_cdrec     = re.compile( '^(/dev/cdrecorder[0-9]*)[ \t]+([^ \t]+)[ \t]+', re.I )
    re_dvd       = re.compile( '^(/dev/dvd[0-9]*)[ \t]+([^ \t]+)[ \t]+', re.I )
    re_iso       = re.compile( '^([^ \t]+)[ \t]+([^ \t]+)[ \t]+(iso|cd)9660', re.I )
    re_automount = re.compile( '^none[ \t]+([^ \t]+).*supermount.*dev=([^,]+).*', re.I )
    re_bymountcd = re.compile( '^(/dev/[^ \t]+)[ \t]+([^ ]*cdrom[0-9]*)[ \t]+', re.I )
    re_bymountdvd= re.compile( '^(/dev/[^ \t]+)[ \t]+([^ ]*dvd[0-9]*)[ \t]+', re.I )
    fd_fstab = open( '/etc/fstab' )
    for line in fd_fstab:
        # Match on the devices /dev/cdrom, /dev/dvd, and fstype iso9660
        match_cd        = re_cd.match( line )
        match_cdrec     = re_cdrec.match( line )
        match_dvd       = re_dvd.match( line )
        match_iso       = re_iso.match( line )
        match_automount = re_automount.match( line )
        match_bymountcd = re_bymountcd.match( line )
        match_bymountdvd= re_bymountdvd.match( line )
        mntdir = ''
        if match_cd or match_bymountcd:
            m = match_cd or match_bymountcd
            mntdir = m.group( 2 )
        elif match_cdrec:
            mntdir = match_cdrec.group( 2 )
        elif match_dvd or match_bymountdvd:
            m = match_dvd or match_bymountdvd
            mntdir = m.group( 2 )
        elif match_iso:
            mntdir = match_iso.group( 2 )
        elif match_automount:
            mntdir = match_automount.group( 1 )
        if mntdir:
            cdpath = mntdir
    fd_fstab.close()
    # Some distros like mine (Foresight Linux) use mtab instead
    fd_mtab = "/etc/mtab"
    if not cdpath and os.path.isfile( fd_mtab ):
        re_cd = re.compile( '^(/dev/[^ ]+)[ ]+(/media/[^/]*)[ ]+udf' )
        for line in open( fd_mtab ):
            match_cd = re_cd.match( line )
            if match_cd:
                mntdir = match_cd.group( 2 )
            if mntdir:
                cdpath = mntdir
    return cdpath

def md5file(file):
    try:
        fp = open(file, 'r')
    except IOError, msg:
        log.Debug('%s: Can\'t open: %s\n' % (file, msg))
        return
    m = md5.md5()
    try:
        while 1:
            data = fp.read(bufsize)
            if not data: break
            m.update(data)
    except IOError, msg:
        log.Debug('%s: I/O error: %s\n' % (file, msg))
        return
    return hexify(m.digest())

def hexify(s):
    res = ''
    for c in s:
        res += '%02x' % ord(c)
    return res 
        
# FIXME: UI Code should be moved to ui.py #378 
class Download:
    widget = None
    uitype = None
    def __init__( self, remote_uri, local_uri, cache=False, uitype=None, widget=None ):
        self.status = DOWNLOAD_NOTREADY
        self.widget = widget
        self.cache = cache
        self.local_uri = urllib.unquote(local_uri)        
        self.uitype = uitype
        if self.CheckCache() and self.cache:
            self.Complete()
            return

        if self.uitype:
            try:
               ui.benign()
            except:
                import ui, gobject, gtk

        if self.uitype == DL_TILESTATUS:
            status_text = "Downloading: 0 %"
            try:
                ui.winedoors.tree.set_cell_status(self.widget, status_text )
            except: 
                self.uitype = None
        elif self.uitype == DL_POPUP:
            # This feature is useful in some cases, why dont we implement it?
            #self.wn_downloader = ui.Window( "wn_downloader" )
            #self.wn_downloader['lb_file'].set_text( remote_uri )
            pass
        
        if os.path.isfile( remote_uri ):
            # Skip urllib if its a local file.
            shutil.copy( remote_uri, self.local_uri )
        elif remote_uri.startswith ( "http://" ) or remote_uri.startswith ( "ftp://" ):
            try:
                # Try gconf for proxies before crapping out
                if GetProxyFromGconf():
                    proxies = {'http': GetProxyFromGconf()}
                    urllib._urlopener = urllib.FancyURLopener(proxies)
            except:
                pass
            try:
                urllib.urlretrieve( remote_uri, self.local_uri, self.UpdateProgress )
            except IOError:
                log.Error( "Unable to download file: " + remote_uri )
                self.status = DOWNLOAD_FAILED
                return
            #self.wn_downloader['wn_downloader'].hide()
        self.Complete()
        self.status = DOWNLOAD_OK
          
    def UpdateProgress( self, blocks, block_size, total_size ):
            percentage = float ( blocks * block_size ) / total_size
            if percentage > 1:
                percentage = 1

            status_text = "Downloading: %s %%" % int ( percentage * 100 )

            if self.uitype != None:
                try:
                   ui.benign()
                except:
                    import ui, gobject, gtk
            
            if self.uitype == DL_WIDGET:
                #self.widget.set_text( text_percent + " %" )
                #self.widget.set_fraction( percentage )
                pass
            elif self.uitype == DL_POPUP:
                #self.wn_downloader['pb_downloader'].set_text( text_percent + " %" )
                #self.wn_downloader['pb_downloader'].set_fraction( percentage )
                pass
            elif self.uitype == DL_TILESTATUS:
                print status_text + "\r",
                sys.stdout.flush()
                try:
                    ui.winedoors.tree.set_cell_status(self.widget, status_text )
                    ui.winedoors.tree.throb_cell(self.widget)
                except: 
                    print "UI update error for tilestatus"
                    sys.stdout.flush()
                    self.uitype = None
            #else:
                #print status_text + "\r",
                #sys.stdout.flush()
                
    def Complete ( self ):
        if self.local_uri.endswith( "gz" ):
            raw_file = self.local_uri.replace( ".gz", "" )
            if os.path.isfile( self.local_uri ):
                if os.path.isfile( raw_file ):
                    os.remove( raw_file )
                os.system( "gzip -d " + self.local_uri.replace( " ", "\\ " ) )
        if self.widget:
            pass
        
        #print "\n",
        sys.stdout.flush()
        
    def CheckCache ( self ):
        if self.local_uri.endswith( "gz" ):
            cache_file = self.local_uri.replace( ".gz", "" )
        else:
            cache_file = self.local_uri
            
        if self.cache > 1:
            cache_timeout = self.cache * 60 * 60 * 24
        else:
            # This cache shouldn't be hard coded, we should use preferences.xml for it
            # or steal a gconf key?
            cache_timeout = 86400
        
        if os.path.isfile( cache_file ):
            repo_cache = os.stat( cache_file )
            repo_mtime = repo_cache.st_mtime
            repo_mtime += cache_timeout
            if ( repo_mtime < time.time() ):
                os.remove( cache_file )
                return False
        else:
            return False
        return True
        
def printNestedStuff ( stuff, grow = 3, indent = 0, noFirstLine = False ):
    """ Prints a lot of nested lists and dicts in a way that is readable """
    if type( stuff ) in ( list, tuple ):
        char = type( stuff ) == list and "[]" or "()"
        if not noFirstLine:
            print " "*indent + char[0]
        else: print char[0]
        for i in xrange( len( stuff ) ):
            item = stuff[i]
            printNestedStuff( item, grow, indent+grow )
            if not i +1 >= len( stuff ):
                print ","
            else: print
        sys.stdout.write( " "*indent + char[1] )
        
    elif type( stuff ) == dict:
        if not noFirstLine:
            print " "*indent + "{"
        else: print "{"
        pairs = [( k, v ) for k, v in stuff.iteritems()]
        for i in xrange( len( pairs ) ):
            k, v = pairs[i]
            printNestedStuff( k, grow, indent+grow )
            sys.stdout.write( " : " )
            printNestedStuff( v, grow, indent+grow, True )
            if not i+1 >= len( pairs ):
                print ","
            else: print
        sys.stdout.write( " "*indent + "}" )
    
    else:
        if not noFirstLine:
            sys.stdout.write( " "*indent + str( stuff ) )
        else: sys.stdout.write( str( stuff ) )

def string2bool( string ):
    # God this is so bad
    """ Fixes TypeError that occurs in prefernces window the second time its opened """
    if string == "True" or string == "1":
        return True
    elif string == "False" or string == "0":
        return False
    else:
        return string

def ClearCache():
    """ Clears the wine-doors cache """
    caches = os.path.expanduser("~/.wine-doors")
    os.system("rm -rf "+caches+"/apppacks/*")
    os.system("rm -f "+caches+"/packlists/*")
    os.system("rm -f "+caches+"/icons/*")

# For wine colours from gtk -- thanks endolith
def format_color_string(Color):
    """ Convert 48-bit gdk.Color to 24-bit "RRR GGG BBB" triple. """
    return "%s %s %s" % (Color.red/256, Color.green/256,  Color.blue/256)

def format_hex_color(color):
    """ Convert from #rrrrggggbbbb string to decimal "RRR GGG BBB" triple. """
    r, g, b = color[1:3], color[5:7], color[9:11]
    return "%s %s %s" % (int(r,16), int(g,16), int(b,16))

def getwinecoloursfromgtk():
    """ Returns a dict containing colours from 
        the current gtk theme and their wine names """
    # Get some colors from GTK
    # gtk.Style object:
    # http://www.moeraki.com/pygtkreference/pygtk2reference/class-gtkstyle.html

    # Create a window to scrape colors from
    window = gtk.Window()

    button = gtk.Button()
    vbox = gtk.VBox()
    vbox.add(button)

    scrollbar =  gtk.VScrollbar()
    vbox.add(scrollbar)

    menubar = gtk.MenuBar()
    menuitem = gtk.MenuItem()
    menubar.add(menuitem)
    vbox.add(menubar)

    window.add(vbox)

    # On show_all(), these are all converted from gtk.Style objects with wrong
    # colors into __main__.EngineStyle objects with correct colors.
    window.show_all()
    window.hide()

    # Tooltips
    # http://www.daa.com.au/pipermail/pygtk/2005-November/011353.html
    tooltip = gtk.Window()
    tooltip.set_name('gtk-tooltips')
    tooltip.show_all()
    tooltip.hide()

    # All of Wine's 31 possible user.reg color values
    # Asterisk * next to comment if I've found a value that works for most themes
    # Question mark ? next to comment if not sure or can't find anywhere to scrape from

    # Some descriptions:
    # http://www.quimp.net/gamemaker/system-colors
    # http://www.endolith.com/wordpress/2008/08/03/wine-colors/
    # http://support.microsoft.com/kb/58336
    # http://msdn.microsoft.com/en-us/library/system.drawing.systemcolors_properties(VS.80).aspx


    return {

    # Doesn't seem to be anything to scrape for these.

    #? Active title bar text - white since we're guessing on dark selection color for titlebar
    'TitleText':             format_color_string( window.style.white ),

    #? Left end of active title bar - guess on selection color like Clearlooks
    'ActiveTitle':           format_color_string( window.style.dark[gtk.STATE_SELECTED] ), 

    #? Right end of active title bar - lighter version for gradient
    'GradientActiveTitle':   format_color_string( window.style.light[gtk.STATE_SELECTED] ), 

    #? Active window border - same as ButtonFace like Clearlooks
    'ActiveBorder':          format_color_string( button.style.bg[gtk.STATE_INSENSITIVE] ),

    #? Inactive title bar text - white since we're guessing on dark color for titlebar
    'InactiveTitleText':     format_color_string( window.style.white ), 

    #? Left end of inactive title bar - darker color for gradient
    'InactiveTitle':         format_color_string( window.style.dark[gtk.STATE_NORMAL] ), 

    #? Right end of inactive title bar - guess on base color
    'GradientInactiveTitle': format_color_string( window.style.base[gtk.STATE_NORMAL] ),  
  
    #? Inactive window border - same as ButtonFace
    'InactiveBorder':        format_color_string( button.style.bg[gtk.STATE_INSENSITIVE] ), 

    #? BG color of MDI, which aren't used in GTK: use same color as Window, like Glade
    'AppWorkSpace':          format_color_string( window.style.base[gtk.STATE_NORMAL] ),

    # Get desktop background color from gconf
    'Background':            gconf.Client().get_value("/desktop/gnome/background/primary_color"), 

    #* Button/tab text and glyphs
    'ButtonText':            format_color_string( button.style.fg[gtk.STATE_NORMAL] ), 

    #* Outermost button higlight / Grayed-out button text shadow
    'ButtonHilight':         format_color_string( button.style.light[gtk.STATE_INSENSITIVE] ), 

    #* Inner button highlight, usually same as ButtonFace
    'ButtonLight':           format_color_string( button.style.bg[gtk.STATE_INSENSITIVE] ), 

    #* Background for buttons and all 3D objects
    'ButtonFace':            format_color_string( button.style.bg[gtk.STATE_INSENSITIVE] ), 

    #* No idea what this does - Set to same as ButtonFace for now
    'ButtonAlternateFace':   format_color_string( button.style.bg[gtk.STATE_INSENSITIVE] ), 

    #* Shadows of buttons / Grayed-out button text
    'ButtonShadow':          format_color_string( button.style.dark[gtk.STATE_INSENSITIVE] ), 

    #* Outermost shadow of buttons
    'ButtonDkShadow':        format_color_string( button.style.black ), 

    # Grayed out text in windows, like labels for unavailable widgets
    'GrayText':              format_color_string( window.style.fg[gtk.STATE_INSENSITIVE] ),

    # Background of selected text
    'Hilight':               format_color_string( window.style.base[gtk.STATE_SELECTED] ), 

    # Selected text
    'HilightText':           format_color_string( window.style.fg[gtk.STATE_SELECTED] ), 

    # Single-click navigation hover color, doesn't seem to exist in GTK; use lighter ButtonFace color, like CompizConfig Settings Manager
    'HotTrackingColor':      format_color_string( window.style.light[gtk.STATE_NORMAL] ), 

    #* ToolTip text
    'InfoText':              format_color_string( tooltip.style.fg[gtk.STATE_NORMAL] ), 

    #* ToolTip background
    'InfoWindow':            format_color_string( tooltip.style.bg[gtk.STATE_NORMAL] ), 

    # Background for menus, also background for menu bars in 3D mode
    'Menu':                  format_color_string( menuitem.style.light[gtk.STATE_ACTIVE] ), 

    # Background for menu bars - rarely seen due to 3D menus
    'MenuBar':               format_color_string( menubar.style.bg[gtk.STATE_NORMAL] ), 

    # Highlight for flat menus - in 3D mode, Hilight is used instead
    'MenuHilight':           format_color_string( menuitem.style.bg[gtk.STATE_PRELIGHT] ), 

    # Menu text
    'MenuText':              format_color_string( menuitem.style.fg[gtk.STATE_NORMAL] ), 

    # Background color of scrollbar, but only in some apps.
    'Scrollbar':             format_color_string( scrollbar.style.bg[gtk.STATE_ACTIVE] ), 

    # Background color of notepad, for instance
    'Window':                format_color_string( window.style.base[gtk.STATE_NORMAL] ), 

    # Glow around focused widget
    'WindowFrame':           format_color_string( button.style.mid[gtk.STATE_SELECTED] ), 

    # Text in notepad, for instance
    'WindowText':            format_color_string( window.style.text[gtk.STATE_NORMAL] ), 

    }


    
